using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.Windows.Forms.Design;

namespace Insiders.Windows.Forms
{
	/// <summary>
	/// MenuButton ̊Tv̐łB
	/// </summary>
	[ToolboxBitmap(typeof(Button))]
	[Designer(typeof(MenuButton.MenuButtonDesigner))]
	public class MenuButton : System.Windows.Forms.Button
	{
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MenuButton()
		{
			// ̌ĂяóAWindows.Forms tH[ fUCiŕKvłB
			InitializeComponent();

			// {^ʏ̏Ԃŏ
			this.btnState = ButtonState.Normal;

			// {^̗̈
			this.Region = new Region(GetButtonRegionPath(0, 0));
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if( components != null )
					components.Dispose();
			}
			base.Dispose( disposing );
		}

		#region R|[lg fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e 
		/// R[hnGfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			components = new System.ComponentModel.Container();
		}
		#endregion

		#region {^̏ԊǗ
		public enum ButtonState
		{
			Normal,	// ʏ̏
			Hover,	// }EX{^̏ɂ
			Pressed	// }EXŉĂ
		}
	
		private ButtonState btnState;	// {^̏Ԃێ
		
		/// <summary>
		/// {^̏̃}EXꂽƂɌĂяoB
		/// </summary>
		/// <param name="e"></param>
		protected override void OnMouseLeave(EventArgs e)
		{
			base.OnMouseLeave (e);
			this.btnState = ButtonState.Normal;
			this.Invalidate();
		}

		/// <summary>
		/// {^̏Ƀ}EXƂɌĂяoB
		/// </summary>
		/// <param name="e"></param>
		protected override void OnMouseEnter(EventArgs e)
		{
			base.OnMouseEnter (e);
			this.btnState = ButtonState.Hover;	
			this.Invalidate();
		}
		
		/// <summary>
		/// {^}EXɂĉꂽƂɌĂяoB
		/// </summary>
		/// <param name="e"></param>
		protected override void OnMouseDown(MouseEventArgs e)
		{
			base.OnMouseDown(e);

			// NbNꂽĕ`
			if (e.Button == MouseButtons.Left)
			{
				this.btnState = ButtonState.Pressed;
				this.Invalidate();
			}

		}

		/// <summary>
		/// {^̏}EXړƂɌĂяoB
		/// </summary>
		/// <param name="e"></param>
		protected override void OnMouseMove(MouseEventArgs e)
		{
			base.OnMouseMove(e);

			if (this.ClientRectangle.Contains(e.X, e.Y)) 
			{
				if ((this.Capture == true) &&
					(this.btnState == ButtonState.Hover))
				{
					// Lv`ԁi}EXꂽ܂܁jŃ{^ԂHoverȂ
					// ܂܃{^̊Oɖ߂ĂƂӖ
					this.btnState = ButtonState.Pressed;
					this.Invalidate();
				} 
			}
			else
			{
				if (this.btnState == ButtonState.Pressed)
				{
					// {^ԂPressedrȂ
					// ܂܃{^̓OɏoĂƂӖ
					this.btnState = ButtonState.Hover;
					this.Invalidate();
				}
			}

		}

		/// <summary>
		/// }EXɂNbNIƂɌĂяoB
		/// </summary>
		/// <param name="e"></param>
		protected override void OnClick(EventArgs e)
		{
			if (this.ClientRectangle.Contains(
				this.PointToClient(Control.MousePosition)))
			{
				// ʏ}EX{^ɂ͂
				this.btnState = ButtonState.Hover;
			}
			else
			{
				// }EX{^ɂȂꍇɂ͒ʏԂɂ
				this.btnState = ButtonState.Normal;
			}
			this.Invalidate();

			base.OnClick (e);
		}

		/// <summary>
		/// {^̗L^̏Ԃ؂ւƂɌĂяoB
		/// </summary>
		/// <param name="e"></param>
		protected override void OnEnabledChanged(EventArgs e)
		{
			base.OnEnabledChanged (e);

			// {^̏Ԃ߂ĕ`
			this.btnState = ButtonState.Normal;
			this.Invalidate();
		}
		#endregion

		#region {^̗̈
		/// <summary>
		/// {^̈̃pX擾
		/// </summary>
		/// <param name="inflate"></param>
		/// <returns></returns>
		private GraphicsPath GetButtonRegionPath(int inflate, int lineWidth)
		{
			Rectangle rc = this.ClientRectangle;

			if (inflate != 0)
			{
				rc.Inflate(inflate, inflate);
			}
			if (lineWidth != 0)
			{
				rc.Width -= lineWidth;
				rc.Height -= lineWidth;
			}

			Size sz = new Size(10, 10);

			GraphicsPath path = new GraphicsPath();
			path.AddLine(rc.Left + sz.Width / 2, rc.Top, rc.Right - sz.Width / 2, rc.Top);
			path.AddArc(rc.Right - sz.Width, rc.Top, sz.Width, sz.Height, 270, 90);
			path.AddLine(rc.Right, rc.Top + sz.Height / 2, rc.Right, rc.Bottom - sz.Height / 2);
			path.AddArc(rc.Right - sz.Width, rc.Bottom - sz.Height, sz.Width, sz.Height, 0, 90);
			path.AddLine(rc.Right - sz.Width / 2, rc.Bottom, rc.Left  + sz.Width / 2, rc.Bottom);
			path.AddArc(rc.Left, rc.Bottom - sz.Height, sz.Width, sz.Height, 90, 90);
			path.AddLine(rc.Left, rc.Bottom - sz.Height / 2, rc.Left, rc.Top + sz.Height / 2);
			path.AddArc(rc.Left, rc.Top, sz.Width, sz.Height, 180, 90);
			
			return path;
		}
		#endregion

		#region {^̕`
		protected override void OnPaint(PaintEventArgs pe)
		{
			// {^`悷
			DrawButton(pe.Graphics);

			// {NXOnPaint͎sȂ
			//base.OnPaint(pe);
		}

		/// <summary>
		/// {^`悷B
		/// </summary>
		/// <param name="g"></param>
		private void DrawButton(Graphics g)
		{
			switch (this.btnState)
			{
				case ButtonState.Normal:   // ʏ̏
					if (this.Enabled == false) 
					{  // {^ȏ
						DrawDisabledButton(g);
					}
					else if (this.Focused)
					{  // {^ɃtH[JX
						DrawFoucusedButton(g);
					}
					else
					{  // ʏ̏
						DrawNormalButton(g);
					}
					break;

				case ButtonState.Hover:    // z[o[
					DrawHoverButton(g);
					break;

				case ButtonState.Pressed:  // 
					DrawPressedButton(g);
					break;
			}

			// eLXg`悷
			this.DrawButtonText(g);
		}

		/// <summary>
		/// ʏԂ̃{^`悵܂B
		/// </summary>
		/// <param name="g"></param>
		private void DrawNormalButton(Graphics g)
		{
			DrawButton(g, this.BackColor, Color.White);
		}
		/// <summary>
		/// Ԃ̃{^`悵܂B
		/// </summary>
		/// <param name="g"></param>
		private void DrawDisabledButton(Graphics g)
		{
			DrawButton(g, SystemColors.ControlDark, Color.White);
		}

		/// <summary>
		/// tH[JXԂ̃{^`悵܂B
		/// </summary>
		/// <param name="g"></param>
		private void DrawFoucusedButton(Graphics g)
		{
			DrawButton(g, Color.Navy, Color.White);
		}

		/// <summary>
		/// }EXɏĂԂ̃{^`悵܂B
		/// </summary>
		/// <param name="g"></param>
		private void DrawHoverButton(Graphics g)
		{
			DrawButton(g, Color.Navy, Color.Yellow);
		}

		/// <summary>
		/// Ԃ̃{^`悵܂B
		/// </summary>
		/// <param name="g"></param>
		private void DrawPressedButton(Graphics g)
		{
			DrawButton(g, SystemColors.Highlight, Color.Black);
		}

		/// <summary>
		/// {^`悷
		/// </summary>
		/// <param name="g"></param>
		/// <param name="colorBack"></param>
		private void DrawButton(Graphics g, Color colorBack, Color colorGradient)
		{
			Rectangle rectPaint = this.ClientRectangle;
			if ((rectPaint.Width <= 0) || (rectPaint.Height <= 0))
			{
				return;	// `悵Ȃ
			}
			Region regionPaint = this.Region;
			if (regionPaint == null)
			{
				return; // `悵Ȃ
			}

			// wiF{^Ŝɕ`
			SolidBrush brushBack = new SolidBrush(colorBack);
			g.FillRegion(brushBack, regionPaint);
			brushBack.Dispose();

			// {^\ʂ̃OfG[V`
			LinearGradientBrush brushSurface = new LinearGradientBrush(
				rectPaint,
				Color.FromArgb(128, colorGradient),
				Color.FromArgb(0, colorGradient),
				LinearGradientMode.Vertical);
			Region reginSurface = new Region(GetButtonRegionPath(-1, 0));
			g.FillRegion(brushSurface, reginSurface);
			brushSurface.Dispose();
		}
		#endregion

		#region {^eLXg̕`
		/// <summary>
		/// {^̃eLXg`悷
		/// </summary>
		/// <param name="g"></param>
		private void DrawButtonText(Graphics g)
		{
			Rectangle rectPaint = this.ClientRectangle;
			if ((rectPaint.Width <= 0) || (rectPaint.Height <= 0))
			{
				return;	// `悵Ȃ
			}

			// {^p̕tH[}bg擾
			StringFormat strFormat = GetButtonStringFormat();

			if (this.btnState == ButtonState.Pressed)
			{
				rectPaint.X += 1; 
				rectPaint.Y += 1; 
				SolidBrush brushText = new SolidBrush(this.ForeColor);
				g.DrawString(this.Text, this.Font, brushText, rectPaint, strFormat);
				brushText.Dispose();
			}
			else if (this.Enabled == true)
			{
				SolidBrush brushText = new SolidBrush(this.ForeColor);
				g.DrawString(this.Text, this.Font, brushText, rectPaint, strFormat);
				brushText.Dispose();
			}
			else
			{
				// Rg[̖`悷ɂ
				// Win32 APIDrawStateString֐gȂB
				// ControlPaint.DrawStringDisabled\bh͂邪
				// M҂A܂삵Ȃ悤B
				// ȂAControlPaint.DrawImageDisabled͎g悤B

				// ł́A1sNZEɂ炷ƂŁA^I3D\ۂ
				SolidBrush brushLightText = new SolidBrush(SystemColors.ControlLightLight);
				g.DrawString(this.Text, this.Font, brushLightText, rectPaint, strFormat);
				brushLightText.Dispose();
				rectPaint.X -= 1; 
				rectPaint.Y -= 1; 
				SolidBrush brushDarkText = new SolidBrush(
					this.Enabled ? this.ForeColor : SystemColors.ControlDark);
				g.DrawString(this.Text, this.Font, brushDarkText, rectPaint, strFormat);
				brushDarkText.Dispose();
			}

			strFormat.Dispose();
		}

		/// <summary>
		/// {^p̕tH[}bg擾B
		/// </summary>
		/// <returns></returns>
		private StringFormat GetButtonStringFormat()
		{
			StringFormat strFormat = new StringFormat();
			strFormat.HotkeyPrefix = System.Drawing.Text.HotkeyPrefix.Show;
			switch (this.TextAlign)
			{
				case ContentAlignment.MiddleCenter:
					strFormat.LineAlignment = StringAlignment.Center;
					strFormat.Alignment = StringAlignment.Center;
					break;
				case ContentAlignment.MiddleLeft:
					strFormat.LineAlignment = StringAlignment.Center;
					strFormat.Alignment = StringAlignment.Near;
					break;
				case ContentAlignment.MiddleRight:
					strFormat.LineAlignment = StringAlignment.Center;
					strFormat.Alignment = StringAlignment.Far;
					break;
				case ContentAlignment.TopCenter:
					strFormat.LineAlignment = StringAlignment.Near;
					strFormat.Alignment = StringAlignment.Center;
					break;
				case ContentAlignment.TopLeft:
					strFormat.LineAlignment = StringAlignment.Near;
					strFormat.Alignment = StringAlignment.Near;
					break;
				case ContentAlignment.TopRight:
					strFormat.LineAlignment = StringAlignment.Near;
					strFormat.Alignment = StringAlignment.Far;
					break;
				case ContentAlignment.BottomCenter:
					strFormat.LineAlignment = StringAlignment.Far;
					strFormat.Alignment = StringAlignment.Center;
					break;
				case ContentAlignment.BottomLeft:
					strFormat.LineAlignment = StringAlignment.Far;
					strFormat.Alignment = StringAlignment.Near;
					break;
				case ContentAlignment.BottomRight:
					strFormat.LineAlignment = StringAlignment.Far;
					strFormat.Alignment = StringAlignment.Far;
					break;
			}
			return strFormat;
		}
		#endregion

		#region TCY̕`揈̉P 
		// OnResizeCxgEventArgsp[^ێ
		private EventArgs resizeEeventArgs = null; 

		//tH[̃TCYύX
		protected override void OnResize(EventArgs e)
		{
			// TCYɃ{^̈ύX
			this.Region = new Region(GetButtonRegionPath(0, 0));

			base.OnResize(e);

			// `揈̓AChԂɍs
			if (resizeEeventArgs == null)
			{
				resizeEeventArgs = e;
				
				// fQ[gǉ
				Application.Idle += new EventHandler(OnIdleInvalidate);
			}
		}

		// AvP[VAChԂ̂ƂɌĂяofQ[g
		private void OnIdleInvalidate(object s, EventArgs e)
		{
			if (resizeEeventArgs != null)
			{
				// `揈s
				Invalidate();

				// fQ[g폜
				resizeEeventArgs = null;
				Application.Idle -= new EventHandler(OnIdleInvalidate);
			}
		}
		#endregion

		#region fUCi\p̓qNX
		/// <summary>
		/// MenuButtonDesigner ̊Tv̐łBiqNXj
		/// </summary>
		internal class MenuButtonDesigner : ControlDesigner
		{
			protected override void PostFilterProperties(IDictionary Properties)
			{
				// ̃vpeB̓fUCił͔\ɂ
				Properties.Remove("FlatStyle");
				Properties.Remove("BackgroundImage");
				Properties.Remove("Image");
				Properties.Remove("ImageAlign");
				Properties.Remove("ImageIndex");
				Properties.Remove("ImageList");
			}
		}
		#endregion
	}
}
